(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('codemirror/addon/display/placeholder'), require('codemirror/addon/edit/continuelist'), require('codemirror/mode/gfm/gfm'), require('codemirror'), require('rxjs'), require('@angular/animations'), require('@angular/cdk/coercion'), require('@angular/common'), require('@angular/forms'), require('@ng-tangram/components/core'), require('@ng-tangram/components/forms'), require('@ng-tangram/pro/markdown-block')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'codemirror/addon/display/placeholder', 'codemirror/addon/edit/continuelist', 'codemirror/mode/gfm/gfm', 'codemirror', 'rxjs', '@angular/animations', '@angular/cdk/coercion', '@angular/common', '@angular/forms', '@ng-tangram/components/core', '@ng-tangram/components/forms', '@ng-tangram/pro/markdown-block'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro['markdown-editor'] = {}),global.ng.core,null,null,null,global.CodeMirror,global.Rx,global.ng.animations,global.ng.cdk.coercion,global.ng.common,global.ng.forms,global.nt.components.core,global.nt.components.forms,global.nt.pro.markdownBlock));
}(this, (function (exports,core,placeholder,continuelist,gfm,codemirror,rxjs,animations,coercion,common,forms,core$1,forms$1,markdownBlock) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NT_MARKDOWN_EDITOR_ICONS = new core.InjectionToken('nt-markdown-editor-icons');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * MarkdownEditor Commands
     */
    // common regexp
    /** @type {?} */
    var LINE_REGEXP = /^([^\n]*)(\n|$)/gm;
    // list regexp
    /** @type {?} */
    var UL_REGEXP = /^[*\-+]\s/;
    /** @type {?} */
    var UL_REGEXP_MULTIPLE = /^([*\-+]\s)([^\n]*)(\n|$)/gm;
    /** @type {?} */
    var OL_REGEXP = /^\d+\.\s+/;
    /** @type {?} */
    var OL_REGEXP_MULTIPLE = /^(\d+\.\s)([^\n]*)(\n|$)/gm;
    /**
     * h1 - h6
     * @param {?} size header 大小值 {范围：1 - 6}
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function header(size, doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        /** @type {?} */
        var single = new RegExp("^#{" + size + "}\\s");
        /** @type {?} */
        var multi = new RegExp("^(#{" + size + "}\\s)([^\\n]*)(\\n|$)", 'gm');
        /**
         * 输入光标位置
         * @type {?}
         */
        var start = doc.getCursor('start');
        /** @type {?} */
        var end = doc.getCursor('end');
        /**
         * 原文内容和替换的内容
         * @type {?}
         */
        var origin = doc.getRange({ line: start.line, ch: 0 }, end);
        /** @type {?} */
        var replacement = '';
        /** @type {?} */
        var symbol = Array(size).fill('#').join('');
        /** @type {?} */
        var startOffset = 0;
        /** @type {?} */
        var endOffset = 0;
        if (erase) {
            replacement = origin.replace(multi, (/**
             * @param {?} _match
             * @param {?} $1
             * @param {?} $2
             * @param {?} $3
             * @return {?}
             */
            function (_match, $1, $2, $3) {
                endOffset = $1.length;
                return "" + $2 + $3;
            }));
            // 计算字符的移位数
            startOffset = doc.getLine(start.line).match(single) ? -size - 1 : 0;
            endOffset = doc.getLine(end.line).match(single) ? -endOffset : 0;
        }
        else {
            replacement = origin
                .replace(/^(#{1,6}\s)([^\n]*)(\n|$)/gm, (/**
             * @param {?} _match
             * @param {?} _$1
             * @param {?} $2
             * @param {?} $3
             * @return {?}
             */
            function (_match, _$1, $2, $3) { return "" + $2 + $3; }))
                .replace(LINE_REGEXP, (/**
             * @param {?} match
             * @return {?}
             */
            function (match) { return !match.trim() && multiple ? match : symbol + " " + match; }));
            // 计算字符的移位数
            startOffset = doc.getLine(start.line).match(single) ? 0 : size + 1;
            endOffset = doc.getLine(end.line).match(single) ? 0 : size + 1;
        }
        // 替换选中的文本
        doc.replaceRange(replacement, { line: start.line, ch: 0 }, end);
        // 重新选中内容, 如果是多行模式尾行的偏移独立计算
        doc.setSelection({ line: start.line, ch: start.ch + startOffset }, { line: end.line, ch: end.ch + (multiple ? endOffset : startOffset) }, { scroll: false });
    }
    /**
     * h1
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function h1(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(1, doc, erase, multiple);
    }
    /**
     * h2
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function h2(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(2, doc, erase, multiple);
    }
    /**
     * h3
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function h3(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(3, doc, erase, multiple);
    }
    /**
     * h4
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function h4(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(4, doc, erase, multiple);
    }
    /**
     * h5
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function h5(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(5, doc, erase, multiple);
    }
    /**
     * h6
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function h6(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        header(6, doc, erase, multiple);
    }
    /**
     * 无序列表命令
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function ul(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        /**
         * 输入光标位置
         * @type {?}
         */
        var start = doc.getCursor('start');
        /** @type {?} */
        var end = doc.getCursor('end');
        /**
         * 原文内容和替换的内容
         * @type {?}
         */
        var origin = doc.getRange({ line: start.line, ch: 0 }, end);
        /** @type {?} */
        var replacement = '';
        /** @type {?} */
        var startOffset = 0;
        /** @type {?} */
        var endOffset = 0;
        if (erase) {
            replacement = origin.replace(UL_REGEXP_MULTIPLE, (/**
             * @param {?} _match
             * @param {?} $1
             * @param {?} $2
             * @param {?} $3
             * @return {?}
             */
            function (_match, $1, $2, $3) {
                endOffset = $1.length;
                return "" + $2 + $3;
            }));
            // 计算字符的移位数
            startOffset = doc.getLine(start.line).match(UL_REGEXP) ? -2 : 0;
            endOffset = doc.getLine(end.line).match(UL_REGEXP) ? -endOffset : 0;
        }
        else {
            replacement = origin.replace(LINE_REGEXP, (/**
             * @param {?} match
             * @return {?}
             */
            function (match) { return !match.trim() && multiple ? match : "- " + match; }));
            // 计算字符的移位数
            startOffset = doc.getLine(start.line).match(UL_REGEXP) ? 0 : 2;
            endOffset = doc.getLine(end.line).match(UL_REGEXP) ? 0 : 2;
        }
        // 替换选中的文本
        doc.replaceRange(replacement, { line: start.line, ch: 0 }, end);
        // 重新选中内容, 如果是多行模式尾行的偏移独立计算
        doc.setSelection({ line: start.line, ch: start.ch + startOffset }, { line: end.line, ch: end.ch + (multiple ? endOffset : startOffset) }, { scroll: false });
    }
    /**
     * 有序列表命令
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} erase 是否要抹掉
     * @param {?=} multiple 是否是多行状态
     * @return {?}
     */
    function ol(doc, erase, multiple) {
        if (multiple === void 0) { multiple = false; }
        /**
         * 输入光标位置
         * @type {?}
         */
        var start = doc.getCursor('start');
        /** @type {?} */
        var end = doc.getCursor('end');
        /**
         * 原文内容和替换的内容
         * @type {?}
         */
        var origin = doc.getRange({ line: start.line, ch: 0 }, end);
        /** @type {?} */
        var replacement = '';
        /** @type {?} */
        var startOffset = 0;
        /** @type {?} */
        var index = 0;
        /** @type {?} */
        var endOffset = 0;
        if (erase) {
            replacement = origin.replace(OL_REGEXP_MULTIPLE, (/**
             * @param {?} _match
             * @param {?} $1
             * @param {?} $2
             * @param {?} $3
             * @return {?}
             */
            function (_match, $1, $2, $3) {
                startOffset = startOffset > 0 ? startOffset : $1.length;
                endOffset = $1.length;
                return "" + $2 + $3;
            }));
            // 计算字符的移位数
            startOffset = doc.getLine(start.line).match(OL_REGEXP) ? -startOffset : 0;
            endOffset = doc.getLine(end.line).match(OL_REGEXP) ? -endOffset : 0;
        }
        else {
            replacement = origin.replace(LINE_REGEXP, (/**
             * @param {?} match
             * @return {?}
             */
            function (match) { return !match.trim() && multiple ? match : ++index + ". " + match; }));
            // 计算字符的移位数
            startOffset = doc.getLine(start.line).match(OL_REGEXP) ? 0 : 3;
            endOffset = doc.getLine(end.line).match(OL_REGEXP) ? 0 : index.toString().length + 2;
        }
        // 替换选中的文本
        doc.replaceRange(replacement, { line: start.line, ch: 0 }, end);
        // 重新选中内容, 如果是多行模式尾行的偏移独立计算
        doc.setSelection({ line: start.line, ch: start.ch + startOffset }, { line: end.line, ch: end.ch + (multiple ? endOffset : startOffset) }, { scroll: false });
    }
    /**
     * 链接
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} _erase
     * @param {?=} _multiple
     * @return {?}
     */
    function link(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        /** @type {?} */
        var start = doc.getCursor('start');
        /** @type {?} */
        var end = doc.getCursor('end');
        /** @type {?} */
        var selection = doc.getSelection() || '';
        /** @type {?} */
        var from = { line: start.line, ch: start.ch + 1 };
        /** @type {?} */
        var to = { line: end.line, ch: end.ch + (start.line === end.line ? 1 : 0) };
        doc.replaceRange("[" + selection + "](http://)", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    /**
     * 图片
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} _erase
     * @param {?=} _multiple
     * @return {?}
     */
    function image(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        /** @type {?} */
        var start = doc.getCursor('start');
        /** @type {?} */
        var end = doc.getCursor('end');
        /** @type {?} */
        var selection = doc.getSelection();
        /** @type {?} */
        var from = { line: start.line, ch: start.ch + 2 };
        /** @type {?} */
        var to = { line: end.line, ch: end.ch + (start.line === end.line ? 2 : 0) };
        doc.replaceRange("![" + selection + "](http://)", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    /**
     * 表格
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} _erase
     * @param {?=} _multiple
     * @return {?}
     */
    function table(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        /** @type {?} */
        var template = "\n| Column 1 | Column 2 | Column 3 |\n| -------- | -------- | -------- |\n| Text     | Text     | Text     |\n";
        /** @type {?} */
        var end = doc.getCursor('end');
        doc.replaceRange(template, { line: end.line + 1, ch: 0 });
    }
    /**
     * 加粗
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} _erase
     * @param {?=} _multiple
     * @return {?}
     */
    function bold(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        /** @type {?} */
        var start = doc.getCursor('start');
        /** @type {?} */
        var end = doc.getCursor('end');
        /** @type {?} */
        var selection = doc.getSelection() || '';
        /** @type {?} */
        var from = { line: start.line, ch: start.ch + 2 };
        /** @type {?} */
        var to = { line: end.line, ch: end.ch + (start.line === end.line ? 2 : 0) };
        doc.replaceRange("**" + selection + "**", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    /**
     * 斜体
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} _erase
     * @param {?=} _multiple
     * @return {?}
     */
    function italic(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        /** @type {?} */
        var start = doc.getCursor('start');
        /** @type {?} */
        var end = doc.getCursor('end');
        /** @type {?} */
        var selection = doc.getSelection() || '';
        /** @type {?} */
        var from = { line: start.line, ch: start.ch + 1 };
        /** @type {?} */
        var to = { line: end.line, ch: end.ch + (start.line === end.line ? 1 : 0) };
        doc.replaceRange("*" + selection + "*", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    /**
     * 删除线
     * @param {?} doc CodeMirror.Doc 对象
     * @param {?} _erase
     * @param {?=} _multiple
     * @return {?}
     */
    function strikethrough(doc, _erase, _multiple) {
        if (_multiple === void 0) { _multiple = false; }
        /** @type {?} */
        var start = doc.getCursor('start');
        /** @type {?} */
        var end = doc.getCursor('end');
        /** @type {?} */
        var selection = doc.getSelection() || '';
        /** @type {?} */
        var from = { line: start.line, ch: start.ch + 2 };
        /** @type {?} */
        var to = { line: end.line, ch: end.ch + (start.line === end.line ? 2 : 0) };
        doc.replaceRange("~~" + selection + "~~", start, end, selection);
        doc.setSelection(from, to, { scroll: false });
    }
    /** @type {?} */
    var commands = {
        // 字体样式
        bold: bold, italic: italic, strikethrough: strikethrough,
        // header
        h1: h1, h2: h2, h3: h3, h4: h4, h5: h5, h6: h6,
        // list
        ul: ul, ol: ol,
        // midia
        link: link, image: image, table: table
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtMarkdownEditorConfig = /** @class */ (function () {
        function NtMarkdownEditorConfig() {
            this.actions = [
                ['bold', 'italic', 'strikethrough'],
                ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'],
                // ['code', 'quote'],
                ['ul', 'ol'],
                ['link', 'image', 'table'],
                ['preview', 'help']
            ];
        }
        return NtMarkdownEditorConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DEFAULT_MIN_ROWS = 10;
    /** @type {?} */
    var DEFAULT_MAX_ROWS = 20;
    /** @type {?} */
    var MIN_ROWS_VALUE = 1;
    /** @type {?} */
    var MAX_ROWS_VALUE = 100;
    var NtMarkdownEditorComponent = /** @class */ (function (_super) {
        __extends(NtMarkdownEditorComponent, _super);
        function NtMarkdownEditorComponent(_renderer, _changeDetectorRef, ngControl, platformId, icons) {
            var _this = _super.call(this) || this;
            _this._renderer = _renderer;
            _this._changeDetectorRef = _changeDetectorRef;
            _this.ngControl = ngControl;
            _this.platformId = platformId;
            _this.icons = icons;
            _this._destroy = new rxjs.Subject();
            _this._syncScrollElements = [];
            _this._syncScrollEvent = new rxjs.Subject();
            _this._value = '';
            _this.previewMode = false;
            _this.config = new NtMarkdownEditorConfig();
            _this.activeActions = [];
            _this.activeActionsSnapshot = [];
            _this._minHeight = 100;
            _this._maxHeight = 100;
            _this._focused = false;
            _this.placeholder = '';
            _this._disabled = false;
            _this._required = false;
            _this._minRows = DEFAULT_MIN_ROWS;
            _this._maxRows = DEFAULT_MAX_ROWS;
            _this._theme = 'default';
            _this._onChange = (/**
             * @return {?}
             */
            function () { });
            _this._onTouched = (/**
             * @return {?}
             */
            function () { });
            if (_this.ngControl) {
                _this.ngControl.valueAccessor = _this;
            }
            return _this;
            /** codemirror 在服务器环境下不支持以 es6 模块的方式导入，因此需要以动态加载的方式来处理。 */
            // if (isPlatformBrowser(this.platformId) && !codeMirrorLoaded) {
            //   fromTextArea = require('codemirror').fromTextArea;
            //   require('codemirror/mode/gfm/gfm');
            //   require('codemirror/addon/edit/continuelist');
            //   codeMirrorLoaded = true;
            // }
        }
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () { return this._value; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._value = value;
                if (this.instance) {
                    this.instance.setValue(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "empty", {
            get: /**
             * @return {?}
             */
            function () { return !this.value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "focused", {
            get: /**
             * @return {?}
             */
            function () { return this._focused; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "disabled", {
            get: /**
             * @return {?}
             */
            function () { return this._disabled; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._disabled = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "required", {
            get: /**
             * @return {?}
             */
            function () { return this._required; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._required = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "minRows", {
            get: /**
             * @return {?}
             */
            function () { return this._minRows; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                /** @type {?} */
                var newValue = coercion.coerceNumberProperty(value) || 0;
                this._minRows = newValue < MIN_ROWS_VALUE ? MIN_ROWS_VALUE : newValue;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "maxRows", {
            get: /**
             * @return {?}
             */
            function () { return this._maxRows; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                /** @type {?} */
                var newValue = coercion.coerceNumberProperty(value) || 0;
                this._maxRows = newValue > MAX_ROWS_VALUE ? MAX_ROWS_VALUE : newValue;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "theme", {
            get: /**
             * @return {?}
             */
            function () { return this._theme; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._theme = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownEditorComponent.prototype, "history", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.instance) {
                    /** @type {?} */
                    var doc = this.instance.getDoc();
                    return doc.historySize();
                }
                return { undo: 0, redo: 0 };
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (common.isPlatformBrowser(this.platformId)) {
                this._codeMirrorInit();
            }
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            /** @type {?} */
            var rowChanges = changes.minRows || changes.maxRows;
            if (rowChanges && !rowChanges.firstChange) {
                this._setEditorHeightRange();
            }
        };
        /**
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._destroy.next();
            this._destroy.complete();
            this._unsubscribeScrolls();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.value = value;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onTouched = fn;
        };
        /**
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.focus = /**
         * @return {?}
         */
        function () {
            if (!this.disabled) {
                this.instance.focus();
            }
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this._disabled = isDisabled;
        };
        /**
         * @param {?} type
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.execCommand = /**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            var _this = this;
            if (type === 'preview') {
                this.previewMode = !this.previewMode;
                this._actionMatches();
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.instance.refresh();
                    _this.previewMode ? _this._subscribeScrolls() : _this._unsubscribeScrolls();
                }));
            }
            else if (type === 'help') {
                window.open('https://guides.github.com/features/mastering-markdown/', '_blank');
            }
            else {
                /** @type {?} */
                var activeted = this.activeActions.indexOf(type) > -1;
                /** @type {?} */
                var doc = this.instance.getDoc();
                /** @type {?} */
                var start = doc.getCursor('start');
                /** @type {?} */
                var end = doc.getCursor('end');
                /** @type {?} */
                var multiple = end.line - start.line > 0;
                /** @type {?} */
                var command = commands[type];
                command && command(doc, activeted, multiple);
                this.instance.save();
                this.instance.focus();
            }
        };
        /**
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.undo = /**
         * @return {?}
         */
        function () {
            this.instance.getDoc().undo();
        };
        /**
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype.redo = /**
         * @return {?}
         */
        function () {
            this.instance.getDoc().redo();
        };
        // 开始订阅滚动条同步事件
        // 开始订阅滚动条同步事件
        /**
         * @private
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._subscribeScrolls = 
        // 开始订阅滚动条同步事件
        /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var callback = (/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                /** @type {?} */
                var element = (/** @type {?} */ (event.target));
                /** @type {?} */
                var scrollYUpdated = element.scrollTop !== element.previousScrollY;
                if (scrollYUpdated) {
                    _this._scrollTo(element);
                }
                element.previousScrollY = element.scrollTop;
            });
            /** @type {?} */
            var editorScrollElement = (/** @type {?} */ (this.instance.getScrollerElement()));
            this._syncScrollElements.push(editorScrollElement, this.markdown.nativeElement);
            this._syncScrollElements.forEach((/**
             * @param {?} element
             * @return {?}
             */
            function (element) {
                return element.addEventListener('scroll', element.callback = callback);
            }));
            // 订阅同步滚动事件
            this._syncScrollSubscription = this._syncScrollEvent.subscribe((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                _this._syncScrollElements
                    .filter((/**
                 * @param {?} element
                 * @return {?}
                 */
                function (element) { return event.owner !== element; }))
                    .forEach((/**
                 * @param {?} element
                 * @return {?}
                 */
                function (element) {
                    scrollY = element.previousScrollY = Math.round(event.rateY * (element.scrollHeight - element.clientHeight));
                    if (Math.round(element.scrollTop - scrollY)) {
                        element.scrollTop = scrollY;
                    }
                }));
            }));
            this._scrollTo(editorScrollElement);
        };
        // 取消订阅滚动条同步事件
        // 取消订阅滚动条同步事件
        /**
         * @private
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._unsubscribeScrolls = 
        // 取消订阅滚动条同步事件
        /**
         * @private
         * @return {?}
         */
        function () {
            if (this._syncScrollSubscription && !this._syncScrollSubscription.closed) {
                this._syncScrollSubscription.unsubscribe();
            }
            if (this._syncScrollElements) {
                this._syncScrollElements.forEach((/**
                 * @param {?} element
                 * @return {?}
                 */
                function (element) {
                    return element.removeEventListener('scroll', element.callback);
                }));
                this._syncScrollElements = [];
            }
        };
        /**
         * @private
         * @param {?} element
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._scrollTo = /**
         * @private
         * @param {?} element
         * @return {?}
         */
        function (element) {
            this._syncScrollEvent.next({
                scrollY: element.scrollTop,
                rateY: element.scrollTop / (element.scrollHeight - element.clientHeight),
                owner: element
            });
        };
        /**
         * @private
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._codeMirrorInit = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            if (typeof codemirror.fromTextArea === 'function') {
                this.editor.nativeElement.value = this.value;
                this.instance = codemirror.fromTextArea(this.editor.nativeElement, {
                    mode: 'gfm',
                    lineWrapping: true,
                    theme: this.theme || 'default',
                    placeholder: this.placeholder,
                    extraKeys: { Enter: 'newlineAndIndentContinueMarkdownList' }
                });
                this._setEditorHeightRange();
                this.instance.on('change', this._onCodeMirrorChange.bind(this));
                this.instance.on('cursorActivity', this._onCodeMirrorCursorActivity.bind(this));
                this.instance.on('focus', this._onCodeMirrorFocus.bind(this));
                this.instance.on('blur', this._onCodeMirrorBlur.bind(this));
                this._destroy.subscribe((/**
                 * @return {?}
                 */
                function () {
                    _this.instance.off('change', _this._onCodeMirrorChange);
                    _this.instance.off('cursorActivity', _this._onCodeMirrorCursorActivity);
                    _this.instance.off('focus', _this._onCodeMirrorFocus);
                    _this.instance.off('blur', _this._onCodeMirrorBlur);
                    _this.instance.toTextArea();
                    _this._changeDetectorRef.markForCheck();
                }));
                Promise.resolve().then((/**
                 * @return {?}
                 */
                function () { return _this.instance.refresh(); }));
            }
        };
        /**
         * @private
         * @param {?} instance
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._onCodeMirrorChange = /**
         * @private
         * @param {?} instance
         * @return {?}
         */
        function (instance) {
            this._actionMatches();
            this._value = instance.getValue();
            this._onChange(this._value);
            this._onTouched();
            this._changeDetectorRef.markForCheck();
        };
        /**
         * @private
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._onCodeMirrorCursorActivity = /**
         * @private
         * @return {?}
         */
        function () {
            this._actionMatches();
            this._changeDetectorRef.markForCheck();
        };
        /**
         * @private
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._onCodeMirrorFocus = /**
         * @private
         * @return {?}
         */
        function () {
            this._focused = true;
            this._changeDetectorRef.markForCheck();
        };
        /**
         * @private
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._onCodeMirrorBlur = /**
         * @private
         * @return {?}
         */
        function () {
            this._focused = false;
            this._changeDetectorRef.markForCheck();
        };
        /**
         * @private
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._actionMatches = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var doc = this.instance.getDoc();
            /** @type {?} */
            var start = doc.getCursor('start');
            /** @type {?} */
            var end = doc.getCursor('end');
            /** @type {?} */
            var range = doc.getRange({ line: start.line, ch: 0 }, end);
            this.activeActions = [];
            if (range.match(/^#\s/gm)) {
                this.activeActions.push('h1');
            }
            if (range.match(/^#{2}\s/gm)) {
                this.activeActions.push('h2');
            }
            if (range.match(/^#{3}\s/gm)) {
                this.activeActions.push('h3');
            }
            if (range.match(/^#{4}\s/gm)) {
                this.activeActions.push('h4');
            }
            if (range.match(/^#{5}\s/gm)) {
                this.activeActions.push('h5');
            }
            if (range.match(/^#{6}\s/gm)) {
                this.activeActions.push('h6');
            }
            if (range.match(/^[*\-+]\s/gm)) {
                this.activeActions.push('ul');
            }
            if (range.match(/^\d+\.\s+/gm)) {
                this.activeActions.push('ol');
            }
            if (this.previewMode) {
                this.activeActions.push('preview');
            }
        };
        /**
         * 以文本行数来计算输入窗口的高度。
         */
        /**
         * 以文本行数来计算输入窗口的高度。
         * @private
         * @return {?}
         */
        NtMarkdownEditorComponent.prototype._setEditorHeightRange = /**
         * 以文本行数来计算输入窗口的高度。
         * @private
         * @return {?}
         */
        function () {
            if (common.isPlatformBrowser(this.platformId) && !!this.instance) {
                /** @type {?} */
                var scrollElement = this.instance.getScrollerElement();
                /** @type {?} */
                var style = window.getComputedStyle(scrollElement);
                if (style && style.lineHeight) {
                    /** @type {?} */
                    var lineHeight = parseFloat(style.lineHeight.replace('px', ''));
                    this._minHeight = this.minRows * lineHeight;
                    this._maxHeight = this.maxRows * lineHeight;
                    this._renderer.setStyle(scrollElement, 'min-height', this._minHeight + "px");
                    this._renderer.setStyle(scrollElement, 'max-height', this._maxHeight + "px");
                }
            }
        };
        NtMarkdownEditorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-markdown-editor',
                        template: "<div class=\"nt-markdown-editor-tools\" [class.tools-disable]=\"previewMode\"> <div class=\"tools-group\" *ngFor=\"let group of config.actions\"> <div class=\"tools-item\" *ngFor=\"let action of group\" [class.active]=\"activeActions.indexOf(action) > -1\" (click)=\"execCommand(action)\"> <span [class]=\"icons[action]\"></span> </div> </div> <div class=\"tools-group\"> <div class=\"tools-item\" [class.disabled]=\"history.undo === 0\" (click)=\"undo()\"> <span class=\"fa fa-reply\"></span> </div> <div class=\"tools-item\" [class.disabled]=\"history.redo === 0\" (click)=\"redo()\"> <span class=\"fa fa-share\"></span> </div> </div> </div> <div class=\"nt-markdown-editor-container\"> <div class=\"nt-markdown-editor-content\"> <textarea #editor></textarea> </div> <div #markdown class=\"nt-markdown-editor-preview\" *ngIf=\"previewMode\" [style.minHeight.px]=\"_minHeight\" [style.maxHeight.px]=\"_maxHeight\" [@fade]> <nt-markdown-block [data]=\"value\"></nt-markdown-block> </div> </div> ",
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        providers: [
                            { provide: forms$1.NtFormFieldControl, useExisting: NtMarkdownEditorComponent }
                        ],
                        animations: [
                            animations.trigger('fade', [
                                animations.transition('void => *', core$1.fadeIn(.15))
                            ])
                        ],
                        host: {
                            'class': 'nt-markdown-editor nt-form-control',
                            '[class.focus]': 'focused'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtMarkdownEditorComponent.ctorParameters = function () { return [
            { type: core.Renderer2 },
            { type: core.ChangeDetectorRef },
            { type: forms.NgControl, decorators: [{ type: core.Self }, { type: core.Optional }] },
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
            { type: undefined, decorators: [{ type: core.Inject, args: [NT_MARKDOWN_EDITOR_ICONS,] }] }
        ]; };
        NtMarkdownEditorComponent.propDecorators = {
            editor: [{ type: core.ViewChild, args: ['editor', { static: true },] }],
            markdown: [{ type: core.ViewChild, args: ['markdown', { static: false, read: core.ElementRef },] }],
            value: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            required: [{ type: core.Input }],
            minRows: [{ type: core.Input }],
            maxRows: [{ type: core.Input }],
            theme: [{ type: core.Input }]
        };
        return NtMarkdownEditorComponent;
    }(forms$1.NtFormFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DEFAULT_MARKDOWN_EDITOR_ICONS = {
        bold: 'fa fa-bold',
        italic: 'fa fa-italic',
        strikethrough: 'fa fa-strikethrough',
        h1: 'fa fa-heading fa-heading-x fa-heading-1',
        h2: 'fa fa-heading fa-heading-x fa-heading-2',
        h3: 'fa fa-heading fa-heading-x fa-heading-3',
        h4: 'fa fa-heading fa-heading-x fa-heading-4',
        h5: 'fa fa-heading fa-heading-x fa-heading-5',
        h6: 'fa fa-heading fa-heading-x fa-heading-6',
        code: 'fa fa-code',
        quote: 'fa fa-quote-left',
        ul: 'fa fa-list-ul',
        ol: 'fa fa-list-ol',
        link: 'fa fa-link',
        image: 'fa fa-image',
        table: 'fa fa-table',
        line: 'fa fa-minus',
        preview: 'fas fa-columns',
        help: 'fab fa-markdown',
    };
    var ɵ0 = DEFAULT_MARKDOWN_EDITOR_ICONS;
    var NtMarkdownEditorModule = /** @class */ (function () {
        function NtMarkdownEditorModule() {
        }
        /**
         * @param {?=} icons
         * @return {?}
         */
        NtMarkdownEditorModule.forRoot = /**
         * @param {?=} icons
         * @return {?}
         */
        function (icons) {
            if (icons === void 0) { icons = DEFAULT_MARKDOWN_EDITOR_ICONS; }
            return {
                ngModule: NtMarkdownEditorModule,
                providers: [
                    { provide: NT_MARKDOWN_EDITOR_ICONS, useValue: icons }
                ]
            };
        };
        NtMarkdownEditorModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, markdownBlock.NtMarkdownBlockModule],
                        exports: [NtMarkdownEditorComponent],
                        declarations: [NtMarkdownEditorComponent],
                        providers: [
                            { provide: NT_MARKDOWN_EDITOR_ICONS, useValue: ɵ0 }
                        ]
                    },] },
        ];
        return NtMarkdownEditorModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtMarkdownEditorModule = NtMarkdownEditorModule;
    exports.NtMarkdownEditorComponent = NtMarkdownEditorComponent;
    exports.NT_MARKDOWN_EDITOR_ICONS = NT_MARKDOWN_EDITOR_ICONS;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=markdown-editor.umd.js.map
