import { Component, Input, ViewEncapsulation, Output, EventEmitter, NgModule } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtDrawerComponent {
    constructor() {
        this._expanded = false;
        this.open = new EventEmitter();
        this.expandedChange = new EventEmitter();
        this._size = '200px';
        this._expandFrom = 'right';
    }
    /**
     * @return {?}
     */
    get expanded() { return this._expanded; }
    /**
     * @param {?} value
     * @return {?}
     */
    set expanded(value) {
        this._expanded = coerceBooleanProperty(value);
        this.expandedChange.emit(this._expanded);
        if (this._expanded) {
            this.open.emit();
        }
    }
    /**
     * @return {?}
     */
    get size() { return this._size; }
    /**
     * @param {?} value
     * @return {?}
     */
    set size(value) {
        this._size = value;
    }
    /**
     * @return {?}
     */
    get expandFrom() { return this._expandFrom; }
    /**
     * @param {?} value
     * @return {?}
     */
    set expandFrom(value) {
        this._expandFrom = value;
    }
    /**
     * @return {?}
     */
    isFromHorizontal() {
        return this.expandFrom === 'right' || this.expandFrom === 'left';
    }
    /**
     * @return {?}
     */
    isFromVertical() {
        return this.expandFrom === 'top' || this.expandFrom === 'bottom';
    }
}
NtDrawerComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-drawer',
                template: `
    <div class="nt-drawer-overlay {{expandFrom}}"
      [class.is-expanded]="expanded"
      [style.width]="isFromHorizontal() ? size : 'auto'"
      [style.height]="isFromVertical() ? size : 'auto'">
      <ng-content></ng-content>
    </div>
    <div *ngIf="expanded" class="nt-drawer-backdrop" (click)="expanded = false"></div>
  `,
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-drawer'
                }
            },] },
];
NtDrawerComponent.propDecorators = {
    open: [{ type: Output }],
    expandedChange: [{ type: Output }],
    expanded: [{ type: Input }],
    size: [{ type: Input }],
    expandFrom: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtDrawerModule {
}
NtDrawerModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [NtDrawerComponent],
                declarations: [NtDrawerComponent],
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtDrawerModule, NtDrawerComponent };
//# sourceMappingURL=drawer.js.map
