import { Component, Input, ViewEncapsulation, Output, EventEmitter, NgModule } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtDrawerComponent = /** @class */ (function () {
    function NtDrawerComponent() {
        this._expanded = false;
        this.open = new EventEmitter();
        this.expandedChange = new EventEmitter();
        this._size = '200px';
        this._expandFrom = 'right';
    }
    Object.defineProperty(NtDrawerComponent.prototype, "expanded", {
        get: /**
         * @return {?}
         */
        function () { return this._expanded; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._expanded = coerceBooleanProperty(value);
            this.expandedChange.emit(this._expanded);
            if (this._expanded) {
                this.open.emit();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtDrawerComponent.prototype, "size", {
        get: /**
         * @return {?}
         */
        function () { return this._size; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._size = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtDrawerComponent.prototype, "expandFrom", {
        get: /**
         * @return {?}
         */
        function () { return this._expandFrom; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._expandFrom = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NtDrawerComponent.prototype.isFromHorizontal = /**
     * @return {?}
     */
    function () {
        return this.expandFrom === 'right' || this.expandFrom === 'left';
    };
    /**
     * @return {?}
     */
    NtDrawerComponent.prototype.isFromVertical = /**
     * @return {?}
     */
    function () {
        return this.expandFrom === 'top' || this.expandFrom === 'bottom';
    };
    NtDrawerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-drawer',
                    template: "\n    <div class=\"nt-drawer-overlay {{expandFrom}}\"\n      [class.is-expanded]=\"expanded\"\n      [style.width]=\"isFromHorizontal() ? size : 'auto'\"\n      [style.height]=\"isFromVertical() ? size : 'auto'\">\n      <ng-content></ng-content>\n    </div>\n    <div *ngIf=\"expanded\" class=\"nt-drawer-backdrop\" (click)=\"expanded = false\"></div>\n  ",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        'class': 'nt-drawer'
                    }
                },] },
    ];
    NtDrawerComponent.propDecorators = {
        open: [{ type: Output }],
        expandedChange: [{ type: Output }],
        expanded: [{ type: Input }],
        size: [{ type: Input }],
        expandFrom: [{ type: Input }]
    };
    return NtDrawerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtDrawerModule = /** @class */ (function () {
    function NtDrawerModule() {
    }
    NtDrawerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [NtDrawerComponent],
                    declarations: [NtDrawerComponent],
                },] },
    ];
    return NtDrawerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtDrawerModule, NtDrawerComponent };
//# sourceMappingURL=drawer.js.map
